unit DecompSv; {$N+,E+}

{    祭  楤 DECOMP  SOLVE,
  ᯮ짮  襭  ⥬
ࠢ ⮤ ᮢ ᪫祭   롮஬
饣 .   DECOMP 믮  
⬠,     ᢮  -
⮢.  ࠭ ⥫  ଠ  
,  楤 SOLVE ᯮ  १,
⮡  襭  ந쭮 ࠢ .
᪮  ⢨⥫  訡 㣫, 
⢥  ⢥ ⨯  㫥 ਭ ⨯
RealType = Extended. ᫨   ᭠饭 ᮯ஬,
   먣  ᪮, நࠢ  筮,
 ८।  ⨯  RealType = Real. }

	INTERFACE
type
  RealType = Extended;
  ArrayType = array [1..(2*MaxInt) div SizeOf(RealType)]
		of RealType;

procedure Solve(N : Word; var AI, BI, IpvtI);
{ 襭  ⥬ A * X = B.
楤  ᫥ ᯮ짮, ᫨ Decomp
㦨 ஦  A.
	室 ଠ:
  N - 冷 
  A - 䠪ਧ஢ , 祭  Decomp
  B -  ࠢ ⥩
  Ipvt -   ⮢, 祭  Decomp
	室 ଠ:
  B -  襭 X }

procedure Decomp(N : Word; var AI, IpvtI, WorkI;
				var Cond : RealType);
{  ࠧ ⢥  ।⢮
ᮢ ᪫祭  業 ᫮ .
 ᯮ  ᫥ 襭  ⥬:
	室 ଠ:
  N - 冷 
  AI - ,  㦭 ࠧ
  WorkI - ࠡ稩 ᨢ.
	室 ଠ:
  A - ᮤন  㣮  U  뢠
⠭   㣮쭮  1-L, ⠪,
 ( ⠭) * A = L * U;
  IpvtI -   ⮢, 祬 IpvtI[k] - 
k- 饩 ப, IpvtI[N] = (-1)^(᫮ ⠭);
  Cond - 業 ᫮ A.   ⥬
A * X = B   A  B  맢   X,
訥  Cond ࠧ. ᫨ Cond + 1 = Cond,   ।
設 筮  A - ஦. Cond 
ࠢ 1.0E+32, ᫨ 㦥 筠 ஦.
  ।⥫  A   祭  室
 㫥:
    Det(A) = Ipvt[N] * A[1, 1] * A[2, 2] * ... * A[N, N] }

	IMPLEMENTATION

function Indx(N, i, j : Integer) : Integer;
{  ᯮ⥫쭠 㭪  
  ᨢ-ப  祭 ᮢ I  J
⭮  NxN }
begin
  Indx := N * Pred(i) + j
end;

procedure Solve(N : Word; var AI, BI, IpvtI);
var
  A : ArrayType absolute AI;
  B : ArrayType absolute BI;
  Ipvt : array [1..MaxInt] of Integer absolute IpvtI;
  T : RealType;
  i, k, m, kb : integer;
begin
  { אַ 室: }
  if N <> 1 then
  begin
    for k := 1 to N-1 do
    begin
      m := Ipvt[k]; T := B[m];
      B[m] := B[k]; B[k] := T;
      for i := k+1 to N do
        B[i] := B[i] + A[Indx(N, i, k)] * T
    end;
    { ⭠ ⠭: }
    for kb := 1 to N-1 do
    begin
      k := N - kb + 1;
      B[k] := B[k] / A[Indx(N, k, k)]; T := -B[k];
      for i := 1 to N-kb do
        B[i] := B[i] + A[Indx(N, i, k)] * T
    end
  end;
  B[1] := B[1] / A[1]
end { Solve };

procedure Decomp(N : Word; var AI, IpvtI, WorkI;
				var Cond : RealType);
var
  A : ArrayType absolute AI;
  Ipvt : array [1..MaxInt] of Integer absolute IpvtI;
  Work : ArrayType absolute WorkI;
  EK, T, Anorm, Ynorm, Znorm : RealType;
  i, j, k, m, kb : Integer;
begin
  Cond := 1.0E+32; Ipvt[N] := 1;
  if N = 1 then
  { 砩  1x1 }
  begin
    if A[1] <> 0 then Cond := 1;
    exit
  end;
  { ᫨ 1-  A }
  Anorm := 0;
  for j := 1 to N do
  begin
    T := 0;
    for i := 1 to N do T := T + abs(A[Indx(N, i, j)]);
    if T > Anorm then Anorm := T
  end;
  { ᮢ ᪫祭   롮஬
	饣 : }
  for k := 1 to N-1 do
  begin
    {  騩 : }
    m := k;
    for i := k+1 to N do
      if abs(A[Indx(N, i, k)]) > abs(A[Indx(N, m, k)])
	then m := i;
    Ipvt[k] := m;
    if m <> k then Ipvt[N] := -Ipvt[N];
    T := A[Indx(N, m, k)];
    A[Indx(N, m, k)] := A[Indx(N, k, k)];
    A[Indx(N, k, k)] := T;
    { ய  蠣 ᫨ 騩  = 0 }
    if T <> 0 then
    begin
      { ᫨ ⥫: }
      for i := k+1 to N do
	A[Indx(N, i, k)] := -A[Indx(N, i, k)] / T;
      { ⠢  ᪫  ⮫栬: }
      for j := k+1 to N do
      begin
	T := A[Indx(N, m, j)];
	A[Indx(N, m, j)] := A[Indx(N, k, j)];
	A[Indx(N, k, j)] := T;
	if T <> 0 then for i := k+1 to N do
	  A[Indx(N, i, j)] := A[Indx(N, i, j)] +
	    A[Indx(N, i, k)] * T
      end
    end
  end;
{ Cond = (1 - ଠ  A) * (業  1-
, ⭮  A)
  業 砥 ।⢮  蠣 ⮤ 
権  襣 ᨭ୮ .  ॡ
襭  ⥬ ࠢ:
			(A) * Y = E
			A * Z = Y	, :
	E -   +1  -1, ࠭ ⠪, ⮡
		ᨬ஢ 祭 Y.
	A - ࠭ᯮ஢  A
	業 = (1 - ଠ Z) / (1 - ଠ Y)	}
  {  ⥬ (A) * Y = E }
  for k := 1 to N do
  begin
    T := 0;
    if k <> 1 then for i := 1 to k-1 do
      T := T + A[Indx(N, i, k)] * Work[i];
    EK := 1; if T < 0 then EK := -1;
    if A[Indx(N, k, k)] = 0 then exit;
    Work[k] := -(EK + T) / A[Indx(N, k, k)]
  end;
  for kb := 1 to N-1 do
  begin
    k := N - kb; T := 0;
    for i := k+1 to N do
      T := T + A[Indx(N, i, k)] * Work[k];
    Work[k] := T; m := Ipvt[k];
    if m <> k then
    begin
      T := Work[m]; Work[m] := Work[k]; Work[k] := T
    end
  end;
  Ynorm := 0;
  for i := 1 to N do Ynorm := Ynorm + abs(Work[i]);
  {  ⥬ A * Z = Y }
  Solve(N, A, Work, Ipvt); Znorm := 0;
  for i := 1 to N do Znorm := Znorm + abs(Work[i]);
  { 業 ᫮: }
  Cond := Anorm * Znorm / Ynorm;
  if Cond < 1 then Cond := 1
end { Decomp };

end { DecompSv }.