unit Integral; {$N+,E+,F+}

{  ⮬ 㫥 ᮤন 楤 Quanc8 
ணࠬ-㭪 Simpson,   
 ᫨ 祭 । ⥣ࠫ. }

	INTERFACE
type
  RealType = Extended;
  FunType = function(x : RealType) : RealType;

procedure Quanc8(Fun : FunType; A, B, AbsErr,
	RelErr : RealType; var Result, ErrEst : RealType;
		var NoFun : Integer; var Flag : RealType);
{ 業 ⥣ࠫ  Fun(x)  A  B c  -
⥫ 筮. ⮬᪠ ⨢ ணࠬ,
᭮  㫥 ⮭- 8- 浪.
		室 ଠ:
  Fun - ⥣ࠫ쭠 㭪
  A -  । ⥣஢
  B - 孨 । (   A)
  RelErr - ࠭ ⭮⥫쭮 譮 (RelErr >= 0)
  AbsErr - ࠭ ᮫⭮ 譮 (AbsErr >= 0)
		室 ଠ:
  Result - ਡ  ⥣ࠫ, 㤮⢮饥, 
	,  ⪮   ࠭ 譮
  ErrEst - 業 ⢨⥫쭮 訡
  NoFun - ᫮ 祭 㭪樨, ᯮ짮
	 ᫥ Result
  Flag -  . ᫨ Flag ࠢ , 
	Result, ⭮, 㤮⢮  ࠭
	譮. ᫨ Flag = XXX.YYY,  XXX - ᫮
	ࢠ,    뫮 室, 
	0.YYY -  ᭮ ࢠ, ⠢ 
	ࠡ⪨   ,  ணࠬ ਡ-
	  ।쭮 祭  NoFun. }

function Simpson(Fun : FunType; A, B : RealType;
				N : Integer) : RealType;
{  । ⥣ࠫ  㫥 ᮭ.
		室 ଠ:
  Fun - ⥣ࠫ쭠 㭪
  A, B - ࠭ ࢠ ⥣஢
  N - ⢮ ࢠ,  
	ࠧ ࢠ ⥣஢
		室 ଠ:
  Simpson - 祭 ⮩ 㭪樨  ᫥ 
		㫥 ᮭ । ⥣ࠫ. }

	IMPLEMENTATION

function Amax1(x, y : RealType) : RealType;
{  ᮮ⢥饩 ࠭᪮ 㭪樨 }
begin
  if x > y then Amax1 := x else Amax1 := y
end;

procedure Quanc8(Fun : FunType; A, B, AbsErr,
	RelErr : RealType; var Result, ErrEst : RealType;
		var NoFun : Integer; var Flag : RealType);
label 30, 50, 60, 62, 70;
const
  ww = 14175;
var
  w0, w1, w2, w3, w4, Area, x0, f0, Stone, Step, Corl1, temp,
	Qprev, Qnow, Qdiff, Qleft, EstErr, TolErr : RealType;
  Qright : array [1..31] of RealType;
  f, x : array [1..16] of RealType;
  Fsave, Xsave : array [1..8, 1..30] of RealType;
  LevMin, LevMax, LevOut, NoMax, NoFin,
	Lev, Nim, i, j : Integer;
begin
  { ⠯ 1. ᢮ 砫 祭 ६,
	 騬  ࢠ. ஢ ⠭. }
  LevMin := 1; LevMax := 30;
  LevOut := 6; NoMax := 5000;
  NoFin := NoMax-8*(LevMax-LevOut+
			Round(Exp((LevOut+1)*Ln(2))));
  { ᫨ NoFun ⨣ 祭 NoFin,  ॢ. }
  w0 := 3956/ww; w1 := 23552/ww;
  w2 := -3712/ww; w3 := 41984/ww; w4 := -18160/ww;
  { ᢮ 㫥 祭 ६ 㬬 }
  Flag := 0; Result := 0; Corl1 := 0;
  ErrEst := 0; Area := 0; NoFun := 0;
  if A = B then exit;
  { ⠯ 2. ᢮ 砫 祭 ६, -
    騬  ࢠ,  ᮮ⢥⢨   ࢠ }
  Lev := 0; Nim := 1; x0 := A; X[16] := B;
  Qprev := 0; f0 := Fun(x0); NoFun := 9;
  Stone := (B - A) / 16;
  X[8] := (x0 + X[16]) / 2;
  X[4] := (x0 + X[8]) /2 ;
  X[12] := (X[8] + X[16]) / 2;
  X[2] := (x0 + X[4]) / 2;
  X[6] := (X[4] + X[8]) / 2;
  X[10] := (X[8] + X[12]) / 2;
  X[14] := (X[12] + X[16]) / 2;
  for j := 2 to 16 do
    if not Odd(j) then F[j] := Fun(X[j]);
  { ⠯ 3. ᭮ ᫥.
	ॡ Qprev, x0, x2, x4..x16, f0, f2..f16.
	 x1, x3..x15, f1, f3..f15, Qleft,
		Qright, Qnow, Qdiff, Area. }
  30: X[1] := (x0 + X[2]) / 2;
  F[1] := Fun(X[1]);
  for j := 3 to 15 do if Odd(j) then
  begin
    X[j] := (X[j-1] + X[j+1]) / 2;
    F[j] := Fun(X[j])
  end;
  NoFun := NoFun + 8;
  Step := (X[16] - x0) / 16;
  Qleft := (w0*(f0+F[8]) + w1*(F[1]+F[7]) + w2*(F[2]+F[6])
		+ w3*(F[3]+F[5]) + w4*F[4]) * Step;
  Qright[Lev+1] := (w0*(F[8]+F[16]) + w1*(F[9]+F[15]) +
     w2*(F[10]+F[14]) + w3*(F[11]+F[13]) + w4*F[12]) * Step;
  Qnow := Qleft + Qright[Lev+1];
  Qdiff := Qnow - Qprev;
  Area := Area + Qdiff;
  { ⠯ 4. ஢ઠ 室  ࢠ }
  EstErr := Abs(Qdiff) / 1023;
  TolErr := Amax1(AbsErr, RelErr*Abs(Area)) * (Step/Stone);
  if Lev < LevMin then goto 50;
  if Lev >= LevMax then goto 62;
  if NoFun > NoFin then goto 60;
  if EstErr <= TolErr then goto 70;
  { ⠯ 5. 室 . ⠭ ᫥騩 ࢠ }
  50: Nim := 2 * Nim; Lev := Lev + 1;
  {  , ⭮騥  ࠢ 
	ࢠ,  饣 ᯮ짮 }
  for i := 1 to 8 do
  begin
    Fsave[i, Lev] := F[i+8];
    Xsave[i, Lev] := X[i+8]
  end;
  {  , ⭮騥   
		ࢠ,   ᯮ짮 }
  Qprev := Qleft;
  for i := 1 to 8 do
  begin
    j := -i;
    F[2*j+18] := F[j+9];
    X[2*j+18] := X[j+9]
  end;
  goto 30;
  { ⠯ 6, "". ᫮ 祭 㭪樨  
	⮬, ⮡ ॢ ⠭ । }
  60: NoFin := 2 * NoFin;
  LevMax := LevOut;
  Flag := Flag + (B - x0) / (B - A);
  goto 70;
  { 饥 ।쭮 祭 㡨 
		ࠢ LevMax }
  62: Flag := Flag + 1;
  { ⠯ 7. 室  ࢠ  . ਡ
	। ᫠  ६ 㬬 }
  70: Result := Result + Qnow;
  ErrEst := ErrEst + EstErr;
  Corl1 := Corl1 + Qdiff / 1023;
  { ⠭ ᫥騩 ࢠ }
  while Nim <> 2*(Nim div 2) do
  begin
    Nim := Nim div 2;
    Lev := Lev - 1
  end;
  Nim := Nim + 1;
  if Lev > 0 then
  begin
    {  , 室 
	᫥饣 ࢠ }
    Qprev := Qright[Lev];
    x0 := X[16]; f0 := F[16];
    for i := 1 to 8 do
    begin
      F[2*i] := Fsave[i, Lev];
      X[2*i] := Xsave[i, Lev]
    end;
    goto 30
  end;
  { ⠯ 8. ⥫ 樨  室 }
  Result := Result + Corl1;
  { ᯥ, ⮡ 祭 ६ ErrEst 뫮 
	 ஢ 㣫 }
  if ErrEst = 0 then exit;
  repeat
    temp := Abs(Result) + ErrEst;
    if temp <> Abs(Result) then exit;
    ErrEst := 2 * ErrEst
  until false
end { Quanc8 };

function Simpson(Fun : FunType; A, B : RealType;
				N : Integer) : RealType;
var
  H, I : RealType;
  k : Integer;
begin
  H := ((B-A)/N)/2; I := Fun(A);
  for k := 1 to 2*N-1 do if Odd(k) then
	I := I + 4*Fun(A+k*H) else I := I + 2*Fun(A+k*H);
  Simpson := (I + Fun(B))*H/3
end { Simpson };

end { Integral }.