unit MinFun; {$N+,E+,F+}

	INTERFACE

type
  RealType = Extended;
  FunType = function(X : RealType) : RealType;

function Fmin(AX, BX : RealType; F : FunType;
			Tol : RealType) : RealType;
{ 㭪  ਡ x  窥,  F ⨣
㬠  ࢠ [AX, BX].
		室 ଠ:
  AX  -   室 ࢠ
  BX  - ࠢ  室 ࢠ
  F   - ⠢ 짮⥫ ணࠬ-㭪,
	  F(x)   x 
	ࢠ [AX, BX]
  Tol -   ࢠ । 筮
	१ (    ࠢ ).
		室 ଠ:
  Fmin - ,  F ⨣ 㬠.
  ⮤ ᯮ  ᪠ ⮣ 祭  -
⥫쭮 ࠡ᪮ ௮樨. 室 
 뢠 ⥫쭮 㦥, 祬  ᪠ . ᫨ F
 뢭  ந, ⥫  窥
㬠 ( ᮢ饩  窠 AX  BX),  室
ᢥ嫨  筮  冷 ਬ୮ 1,324...
  㭪 F      窠, 
  㣠  祬  Eps*Abs(x) + Tol/3,  Eps ਡ-
⥫쭮 ࠢ ⭮   ⭮⥫쭮 設
筮. ᫨ F - 㭨쭠 㭪  ᫥ 祭
F ࠭ 㭨쭮  ᮡ 㪠 ᫮
ࠧ,  Fmin பᨬ  쭮
㬠 F  ࢠ [AX, BX] c 訡, 襩
3*Eps*Abs(x) + Tol. ᫨ F   㭨쭮,  Fmin
  ⮩  筮 பᨬ஢  ,
,  ᮢ騩  . }

	IMPLEMENTATION

function Sign(A, B : RealType) : RealType;
{  ᮮ⢥饩 ࠭᪮ 㭪樨 }
begin
  if B > 0 then Sign := -Abs(A) else Sign := Abs(A)
end;

function Fmin(AX, BX : RealType; F : FunType;
			Tol : RealType) : RealType;
label 20, 40, 50;
var
  A, B, C, D, E, Eps, XM, P, Q, R, Tol1, Tol2,
		U, V, W, FU, FV, FW, FX, X : RealType;
begin
  { ६ C     稭,
	⭠ ⮬ 祭 }
  C := 0.5*(3 - Sqrt(5));
  { Eps ਡ⥫쭮 ࠢ ⭮  
	⭮⥫쭮 設 筮 }
  Eps := 1; while 1 + Eps/2 <> 1 do Eps := Eps/2;
  Eps := Sqrt(Eps);
  { ᢮ 砫 祭 }
  A := AX; B := BX; V := A + C*(B - A); W := V; X := V;
  E := 0; FX := F(X); FV := FX; FW := FX;
  {  稭 ᭮ 横 }
  20: XM := (A+B)/2; Tol1 := Eps*Abs(X) + Tol/3;
  Tol2 := 2*Tol1;
  { ஢ ਩ 砭 }
  if Abs(X-XM) <= Tol2 - (B-A)/2 then
  begin
    {  ᪠  室 }
    Fmin := X; exit
  end;
  { 室  ⮥ 祭 ? }
  if Abs(E) <= Tol1 then goto 40;
  { ந ࠡ }
  R := (X-W) * (FX-FV); Q := (X-V) * (FX-FW);
  P := (X-V)*Q - (X-W)*R;
  Q := 2*(Q - R); if Q > 0 then P := -P;
  Q := Abs(Q); R:=E; E:=D;
  { ਥ  ࠡ ? }
  if (Abs(P) >= Abs(Q*R/2)) or (P <= Q*(A-X))
    or (P >= Q*(B-X)) then goto 40;
  {  ࠡ᪮ ௮樨 }
  D := P/Q; U := X + D;
  { F  ᫥  ᫨誮   AX  BX }
  if (U-A < Tol2) or (B-U < Tol2) then
    D := Sign(Tol1, XM-X);
  goto 50;
  {  ⮣ 祭 }
  40: if X = XM then E := A - X else E := B - X;
  D := C * E;
  { F  ᫥  ᫨誮   X }
  50: if Abs(D) >= Tol1 then U := X + D
    else U := X + Sign(Tol1, D);
  FU := F(U);
  { ᢮  祭 ࠬࠬ A, B, V, W  X }
  if FU <= FX then
  begin
    if U >= X then A := X else B := X;
    V := W; FV := FW; W := X; FW := FX;
    X := U; FX := FU; goto 20
  end;
  if U < X then A := U else B := U;
  if (FU <= FW) or (W = X) then
  begin
    V := W; FV := FW; W := U; FW := FU
  end
  else if (FU <= FV) or (V = X) or (V = W) then
  begin
    V := U; FV := FU
  end;
  goto 20
end { Fmin };

end { MinFun }.