program TestOfRKF45; {$N+,E+,F+}
{  ணࠬ  ᯮ짮 楤 RKF45
   Runge. ணࠬ 뢠   ⥫ 
  ⢨  ࠢ樮 殮 }
uses Simula, CRT;
const
  NENQ = 4;
var
  AlfaSQ : RealType;

procedure Orb(T : RealType; var YI, YPI);
var
  R : RealType;
  Y : array [1..NENQ] of RealType absolute YI;
  YP : array [1..NENQ] of RealType absolute YPI;
begin
  R := Y[1]*Y[1] + Y[2]*Y[2];
  R := R*Sqrt(R) / AlfaSQ;
  YP[1] := Y[3];
  YP[2] := Y[4];
  YP[3] := -Y[1]/R;
  YP[4] := -Y[2]/R
end;

var
  Y : array [1..NENQ] of RealType;
  Work : array [1..6*NENQ+3] of RealType;
  T, Tout, RelErr, AbsErr, TFinal,
	TPrint, ECC, Alfa : RealType;
  Iflag : Integer;
  IWork : array [1..5] of Integer;
begin
  Clrscr;
  ECC := 0.25;
  Alfa := Pi/4;
  AlfaSQ := Sqr(Alfa);
  T := 0; TFinal := 12; TPrint := 2.0;
  RelErr := 1E-9; AbsErr := 0; Iflag := 1;
  Y[1] := 1-ECC;
  Y[2] := 0;
  Y[3] := 0;
  Y[4] := Alfa*Sqrt((1+ECC)/(1-ECC));
  Tout := TPrint;
  WriteLn('       RKF45:                             Runge:');
  repeat
    RKF45(Orb, NENQ, Y, T, Tout, RelErr, AbsErr,
	Iflag, Work, IWork);
    WriteLn(T:4:1, Y[1]:15:10, Y[2]:15:10);
    case Iflag of
      1: begin
	WriteLn('ࠢ 맮'); Halt(1)
      end;
      2: Tout := Tout + TPrint;
      3: WriteLn('誮 ᮪ ॡ㥬 筮:'#13#10,
		'RelErr = ', RelErr, '   AbsErr = ', AbsErr);
      4: WriteLn('誮  蠣');
      5: begin
	AbsErr := 1E-9;
        WriteLn('誮 ᮪ ॡ㥬 筮:'#13#10,
		'RelErr = ', RelErr, '   AbsErr = ', AbsErr)
      end;
      6: begin
	RelErr := 10*RelErr;
        WriteLn('誮 ᮪ ॡ㥬 筮:'#13#10,
		'RelErr = ', RelErr, '   AbsErr = ', AbsErr)
      end
    end
  until Tout > TFinal;
  Y[1] := 1-ECC;
  Y[2] := 0;
  Y[3] := 0;
  Y[4] := Alfa*Sqrt((1+ECC)/(1-ECC));
  Window(40,2,80,25);
  T := 0;
  repeat
    Runge(Orb, NENQ, Y, T, T+TPrint, 0.02, Work);
    WriteLn(Y[1]:15:10, Y[2]:15:10)
  until T = TFinal
end { TestOfRKF45 }.