unit SplinUNT; {$N+,E+}

{    祭 ணࠬ Spline  Seval.
 襭 筮 ௮樨 ᯮ -
⭠ 䬥⨪  饩 窮, ।塞 ⨯
RealType = Extended. ᫨   ᭠饭 ᮯ஬ 
ॡ  ᪮ ᫥, நࠢ  -
,  ८। RealType = Real. }

	INTERFACE
type
  RealType = Extended;
  RealTypeArray = array [1..(2*MaxInt) div SizeOf(RealType)]
				of RealType;

procedure Spline(N : Word; var XI, YI, BI, CI, DI);
{   B[i], C[i]  D[i], i = 1..N 
㡨᪮ ௮樮 ᯫ 
S(x) = Y[i]+B[i]*(X-X[i])+C[i]*(X-X[i])^2+D[i]*(X-X[i])^3
   X[i] = X = X[i+1]
		室 ଠ:
  N - ᫮  祪  㧫 (N = 2)
  X -  㧫  ண 饬 浪
  Y - न 㧫.
		室 ଠ:
  B, C, D - ᨢ ।  ⮢ ᯫ
᫨  १ P ᨬ ७஢, 
	Y[i] = S(X[i])
	B[i] = SP(X[i])
	C[i] = SPP(X[i])/2
	D[i] = SPPP(X[i])/6 (ࠢ஭ ந).
    ᮯ஢饩 㭪樨 Seval  
祭 ᯫ. }

function Seval(N : Word; var U : RealType;
		var XI, YI, BI, CI, DI) : RealType;
{  㭪  祭 㡨᪮ ᯫ
Seval = Y[i]+B[i]*(U-X[i])+C[i]*(U-X[i])^2+D[i]*(U-X[i])^3
 X[i] < U < X[i+1]. ᯮ 奬 ୥.
᫨ U < X[1],   祭 i = 1, ᫨ U > X[N],
 i = N.
		室 ଠ:
  N - ᫮  祪
  U - ,  ன  祭 ᯫ
  X, Y - ᨢ    न
  B, C, D - ᨢ ⮢ ᯫ,
		᫥ 楤ன Spline
  ᫨  ࠢ  ।騬 맮 U  室 
⮬  ࢠ,   ᪠ 㦭 ࢠ -
  . }

	IMPLEMENTATION

procedure Spline(N : Word; var XI, YI, BI, CI, DI);
var
  ib, i : Integer;
  T : RealType;
  X : RealTypeArray absolute XI;
  Y : RealTypeArray absolute YI;
  B : RealTypeArray absolute BI;
  C : RealTypeArray absolute CI;
  D : RealTypeArray absolute DI;
begin
  if N < 2 then exit;
  if N <> 2 then
  begin
    { ந 夨 ⥬:
	B - ,  - , D - ࠢ  }
    D[1] := X[2] - X[1];
    C[2] := (Y[2] - Y[1])/D[1];
    for i := 2 to N-1 do
    begin
      D[i] := X[i+1] - X[i];
      B[i] := 2*(D[i-1] + D[i]);
      C[i+1] := (Y[i+1] - Y[i])/D[i];
      C[i] := C[i+1] - C[i]
    end;
    { ࠭ ᫮.  ந  窠 X[i] 
	X[N]    ࠧ ࠧ⥩ }
    B[1] := -D[1]; B[N] := -D[N-1];
    C[1] := 0; C[N] := 0;
    if N = 2 then
    begin
      B[1] := (Y[2]-Y[1]) / (X[2]-X[1]);
      C[1] := 0; D[1] := 0;
      B[2] := B[1]; C[2] := 0; D[2] := 0
    end
    else begin
      C[1] := C[3]/(X[4]-X[2])-C[2]/(X[3]-X[1]);
      C[N] := C[N-1]/(X[N]-X[N-2])-
		C[N-2]/(X[N-1]-X[N-3]);
      C[1] := C[1]*Sqr(D[1])/(X[4]-X[1]);
      C[N] := -C[N]*Sqr(D[N-1])/(X[N]-X[N-3])
    end;
    { אַ 室 }
    for i := 2 to N do
    begin
      T := D[i-1]/B[i-1];
      B[i] := B[i]-T*D[i-1];
      C[i] := C[i]-T*C[i-1]
    end;
    { ⭠ ⠭ }
    C[N] := C[N]/B[N];
    for ib := 1 to N-1 do
      C[N-ib] := (C[N-ib]-D[N-ib]*C[N-ib+1])/B[N-ib];
    { ᫨   }
    B[N] := (Y[N]-Y[N-1])/D[N-1]+D[N-1]*(C[N-1]+2*C[N]);
    for i := 1 to N-1 do
    begin
      B[i] := (Y[i+1]-Y[i])/D[i]-D[i]*(C[i+1]+2*C[i]);
      D[i] := (C[i+1]-C[i])/D[i];
      C[i] := 3*C[i]
    end;
    C[N] := 3*C[N]; D[N] := D[N-1]
  end
end { Spline };

function Seval(N : Word; var U : RealType;
		var XI, YI, BI, CI, DI) : RealType;
const
  i : Integer = 1;
var
  j, k : Integer;
  DX : RealType;
  X : RealTypeArray absolute XI;
  Y : RealTypeArray absolute YI;
  B : RealTypeArray absolute BI;
  C : RealTypeArray absolute CI;
  D : RealTypeArray absolute DI;
begin
  if i >= N then i := 1;
  if U < X[i] then
  begin
    {   }
    i := 1; j := N+1;
    repeat
      k := Sqr(i+j);
      if U < X[k] then j := k else i := k
    until j <= i+1
  end;
  { ᫨ ᯫ }
  DX := U - X[i];
  Seval := Y[i]+DX*(B[i]+DX*(C[i]+DX*D[i]))
end { Seval };

end { SplinUNT }.